<template>
	<div
		:class="{
				'minicart': true,
				'minicart--open': isOpened
			}"
		id="minicart"
	>
		<div class="minicart__overlay" @click="closeCart"></div>

		<div
			class="minicart__container"
			:style="{
				height: getHeight
			}"
		>
			<div class="minicart__wrapper">
				<div class="minicart__section minicart__section--header">
					<div class="minicart__header">
						<button
							type="button"
							class="minicart__header-close"
							@click="closeCart"
						>
							<IconClose/>
						</button>

						<h4 class="minicart__header-title">
							{{ 'sections.cart.title' | t }}
						</h4>

						<div class="minicart__header-shipping-module">
							<ShippingModule
								:cart-total="cart.total_price"
								:free-shipping-threshold="100000"
							/>
						</div>
					</div>
				</div>

				<div class="minicart__body">
					<div class="minicart__section minicart__section--items js-minicart-items">
						<div class="minicart__empty" v-if="isEmptyMinicart">
							<EmptyMinicart
								:button-text="customizer.button_text"
								:button-link="customizer.button_link"
							/>
						</div>

						<div class="minicart__products" v-else>
							<div class="minicart__product" v-for="item in cart.items">
								<MinicartItem
									:item="item"
								/>
							</div>
						</div>
					</div>
				</div>

				<div class="minicart__section minicart__section--footer" v-if="!isEmptyMinicart">
					<div class="minicart__footer">
						<div class="minicart__footer-subtotal">
							<p class="minicart__footer-subtotal-label">
								{{ 'sections.cart.subtotal' | t }}
							</p>

							<p class="minicart__footer-subtotal-value">
								{{ cart.total_price | money() }}
							</p>
						</div>

						<div class="minicart__footer-actions">
							<a
								:href="checkoutUrl | routes"
								class="button button--primary button--full-width minicart__footer-action"
							>
								{{ 'sections.cart.checkout' | t }}
							</a>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import {
	createNamespacedHelpers
} from 'vuex';

import IconClose from './../../icons/icon-close.svg';

import EmptyMinicart from './components/minicart/EmptyMinicart';
import ShippingModule from './components/shipping-module/ShippingModule';
import MinicartItem from './components/minicart/MinicartItem';

const { mapState, mapActions, mapGetters } = createNamespacedHelpers("cart");

import {
	CHECKOUT
} from '../core/objects';

import {
	GETTER_CART,
	GETTER_SETTINGS
} from './store/cart/cart';

let resizeChange = null;

const selectors = {
	scrollableContent: '.js-minicart-items'
};

export default {
	name: 'Minicart',
	data: () => ({
		isOpened: false,
		height: window.innerHeight,
		customizer: {},
		checkoutUrl: CHECKOUT
	}),
	mounted() {
		document.addEventListener('minicart:open', this.openCart);

		window.addEventListener('resize', () => {
			clearTimeout(resizeChange);

			resizeChange = setTimeout(() => {
				this.height = window.innerHeight;
			}, 50);
		});

		this.initCustomizer();
	},
	computed: {
		...mapGetters([
			GETTER_CART,
			GETTER_SETTINGS
		]),
		getHeight() {
			return `${this.height}px`;
		},
		isEmptyMinicart() {
			return this.cart.item_count === 0;
		}
	},
	methods: {
		initCustomizer() {
			const customizerDataHolder = document.getElementById('minicart-customizer-data');

			if(!customizerDataHolder) {
				return null;
			}

			try {
				const data = JSON.parse(customizerDataHolder.innerHTML);

				this.customizer = Object.assign({}, {}, data.customizer);
			} catch (error) {}
		},
		closeCart(event) {
			if (event) {
				event.preventDefault();
			}

			this.clearBodyScroll();

			this.isOpened = false;
		},
		openCart() {
			this.disableBodyScroll();

			this.isOpened = true;
		},
		clearBodyScroll() {
			bodyScrollLock.clearAllBodyScrollLocks();
			this.$el.querySelector(selectors.scrollableContent).scrollTo(0, 0);
		},
		disableBodyScroll() {
			bodyScrollLock.disableBodyScroll(this.$el.querySelector(selectors.scrollableContent));
		}
	},
	components: {
		IconClose,
		EmptyMinicart,
		ShippingModule,
		MinicartItem
	}
}
</script>
